# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: unacast/metric/v1/dimension.proto, unacast/metric/v1/metric_value.proto, unacast/metric/v1/metric_report.proto, unacast/metric/v1/lens.proto, unacast/metric/v1/metric.proto, unacast/metric/v1/lens_service.proto, unacast/metric/v1/metric_parent.proto, unacast/metric/v1/metric_service.proto
# plugin: python-betterproto
from dataclasses import dataclass
from typing import List, Optional

import betterproto
import grpclib


class Cadence(betterproto.Enum):
    CADENCE_UNSPECIFIED = 0
    DAILY = 1
    WEEKLY = 2
    MONTHLY = 3
    QUARTERLY = 4
    YEARLY = 5


class ValueKind(betterproto.Enum):
    KIND_UNSPECIFIED = 0
    NUMBER = 1
    COUNT = 2
    CATEGORY = 3


class LifecycleStage(betterproto.Enum):
    UNSPECIFIED = 0
    PROTOTYPE = 3
    RELEASE_CANDIDATE = 6
    STABLE = 9
    DEPRECATED = 12
    ARCHIVED = 15
    DELETED = 18


@dataclass(eq=False, repr=False)
class Dimension(betterproto.Message):
    name: str = betterproto.string_field(4)
    dimension_id: str = betterproto.string_field(1)
    catalog_id: str = betterproto.string_field(2)
    display_name: str = betterproto.string_field(5)
    description: str = betterproto.string_field(6)
    index_id: str = betterproto.string_field(9)
    index: "__index_v1__.Index" = betterproto.message_field(11)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class DimensionValue(betterproto.Message):
    # @exclude @inject_tag: `bigquery:"dimension_id"`
    dimension_id: str = betterproto.string_field(1)
    # @exclude @inject_tag: `bigquery:"value"`
    value: str = betterproto.string_field(2)
    # @exclude @inject_tag: `bigquery:"display_name"`
    display_name: str = betterproto.string_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class DimensionFilter(betterproto.Message):
    dimension_id: str = betterproto.string_field(1)
    values: List[str] = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MapFeatureRef(betterproto.Message):
    layer_id: str = betterproto.string_field(1)
    feature_id: str = betterproto.string_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MetricValue(betterproto.Message):
    # @exclude @inject_tag: `bigquery:"dimension_id"`
    metric_id: str = betterproto.string_field(1)
    # @exclude @inject_tag: `bigquery:"value"`
    observation_period: "Period" = betterproto.message_field(3)
    # @exclude @inject_tag: `bigquery:"display_name"`
    map_feature_v2: "__maps_v1__.Feature" = betterproto.message_field(9)
    related_map_feature: "__maps_v1__.Feature" = betterproto.message_field(5)
    dimensions: List["DimensionValue"] = betterproto.message_field(6)
    supporting_values: List["MetricValueValue"] = betterproto.message_field(7)
    value: "MetricValueValue" = betterproto.message_field(2)
    flags: List["MetricValueFlag"] = betterproto.message_field(8)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MetricValueValue(betterproto.Message):
    name: str = betterproto.string_field(1)
    unit: str = betterproto.string_field(2)
    number: float = betterproto.float_field(9, group="value")
    count: int = betterproto.int64_field(10, group="value")
    category: str = betterproto.string_field(11, group="value")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MetricValueFlag(betterproto.Message):
    code: str = betterproto.string_field(1)
    display_name: str = betterproto.string_field(2)
    detail: str = betterproto.string_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Period(betterproto.Message):
    start: "__unatype__.Date" = betterproto.message_field(1)
    end: "__unatype__.Date" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MetricReport(betterproto.Message):
    observation_period: "Period" = betterproto.message_field(3)
    total_size: int = betterproto.int32_field(4)
    address_components: List["AddressComponentReport"] = betterproto.message_field(5)
    value_p1: float = betterproto.float_field(6)
    value_p5: float = betterproto.float_field(7)
    value_p25: float = betterproto.float_field(8)
    value_p50: float = betterproto.float_field(9)
    value_p75: float = betterproto.float_field(10)
    value_p95: float = betterproto.float_field(11)
    value_p99: float = betterproto.float_field(12)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class AddressComponentReport(betterproto.Message):
    # @exclude @inject_tag: `bigquery:"dimension_id"`
    component: str = betterproto.string_field(1)
    # @exclude @inject_tag: `bigquery:"value"`
    cardinality: int = betterproto.int32_field(2)
    # @exclude @inject_tag: `bigquery:"display_name"`
    short_name: str = betterproto.string_field(3)
    display_name: str = betterproto.string_field(4)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Lens(betterproto.Message):
    id: str = betterproto.string_field(1)
    catalog_id: str = betterproto.string_field(2)
    metric_id: str = betterproto.string_field(3)
    billing_account_id: str = betterproto.string_field(4)
    creator_email: str = betterproto.string_field(5)
    lens_filters: "LensFilters" = betterproto.message_field(6)
    display_name: str = betterproto.string_field(10)
    description: str = betterproto.string_field(11)
    update_time_string: str = betterproto.string_field(13)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LensFilters(betterproto.Message):
    # @exclude @inject_tag: `bigquery:"dimension_id"`
    period_filters: List["Period"] = betterproto.message_field(1)
    # @exclude @inject_tag: `bigquery:"value"`
    dimension_filters: List["DimensionFilter"] = betterproto.message_field(2)
    # @exclude @inject_tag: `bigquery:"display_name"`
    address_component_filters: List[
        "__maps_v1__.AddressComponentFilter"
    ] = betterproto.message_field(3)
    feature_filters: List[str] = betterproto.string_field(4)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Metric(betterproto.Message):
    id: str = betterproto.string_field(1)
    catalog_id: str = betterproto.string_field(2)
    index_id: str = betterproto.string_field(3)
    index: "__index_v1__.Index" = betterproto.message_field(4)
    lifecycle_stage: "LifecycleStage" = betterproto.enum_field(9)
    version_spec: "VersionSpec" = betterproto.message_field(18)
    metric_parent_id: str = betterproto.string_field(19)
    spec: "MetricSpec" = betterproto.message_field(5)
    layer_id: str = betterproto.string_field(6)
    layer: "__maps_v1__.Layer" = betterproto.message_field(8)
    related_layer_id: str = betterproto.string_field(12)
    related_layer: "__maps_v1__.Layer" = betterproto.message_field(13)
    dimensions: List["Dimension"] = betterproto.message_field(7)
    name: str = betterproto.string_field(10)
    listing: str = betterproto.string_field(11)
    report: "MetricReport" = betterproto.message_field(14)
    your_subscription: "__subscription_v1__.SubscriptionStatus" = (
        betterproto.message_field(15)
    )
    your_lens: "Lens" = betterproto.message_field(17)
    description: str = betterproto.string_field(16)
    index_update_time: str = betterproto.string_field(20)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MetricSpec(betterproto.Message):
    # @exclude @inject_tag: `bigquery:"dimension_id"`
    layer_id: str = betterproto.string_field(1)
    # @exclude @inject_tag: `bigquery:"value"`
    related_layer_id: str = betterproto.string_field(2)
    # @exclude @inject_tag: `bigquery:"display_name"`
    cadence: "Cadence" = betterproto.enum_field(4)
    dimensions: List["DimensionSpec"] = betterproto.message_field(5)
    values: List["ValueSpec"] = betterproto.message_field(7)
    value_kind: "ValueKind" = betterproto.enum_field(3)
    unit: str = betterproto.string_field(6)
    tags: List["TagSpec"] = betterproto.message_field(8)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class VersionSpec(betterproto.Message):
    version: str = betterproto.string_field(1)
    release_notes: str = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class DimensionSpec(betterproto.Message):
    dimension_id: str = betterproto.string_field(1)
    default_value: str = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ValueSpec(betterproto.Message):
    name: str = betterproto.string_field(1)
    value_kind: "ValueKind" = betterproto.enum_field(2)
    unit: str = betterproto.string_field(3)
    display_name: str = betterproto.string_field(4)
    description: str = betterproto.string_field(5)
    supporting_value: bool = betterproto.bool_field(6)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class TagSpec(betterproto.Message):
    type: str = betterproto.string_field(1)
    values: List[str] = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Value(betterproto.Message):
    name: str = betterproto.string_field(1)
    value: str = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class DeleteLensRequest(betterproto.Message):
    billing_context: str = betterproto.string_field(1)
    lens_id: str = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ListLensesRequest(betterproto.Message):
    # @exclude @inject_tag: `bigquery:"dimension_id"`
    catalog_id: str = betterproto.string_field(1)
    # @exclude @inject_tag: `bigquery:"value"`
    billing_context: str = betterproto.string_field(2)
    # @exclude @inject_tag: `bigquery:"display_name"`
    creator_email_filter: str = betterproto.string_field(3)
    metric_id_filter: List[str] = betterproto.string_field(4)
    page_size: int = betterproto.int32_field(5)
    page_token: str = betterproto.string_field(6)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ListLensesResponse(betterproto.Message):
    lenses: List["Lens"] = betterproto.message_field(1)
    response_size: int = betterproto.int32_field(2)
    next_page_token: str = betterproto.string_field(6)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class GetLensRequest(betterproto.Message):
    billing_context: str = betterproto.string_field(1)
    lens_id: str = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class CreateLensRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(2)
    metric_id: str = betterproto.string_field(3)
    billing_account_id: str = betterproto.string_field(11)
    lens_filters: "LensFilters" = betterproto.message_field(6)
    display_name: str = betterproto.string_field(9)
    description: str = betterproto.string_field(10)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class CreateLensResponse(betterproto.Message):
    lens: "Lens" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MetricParent(betterproto.Message):
    id: str = betterproto.string_field(1)
    catalog_id: str = betterproto.string_field(2)
    display_name: str = betterproto.string_field(3)
    description: str = betterproto.string_field(4)
    spec: "MetricParentSpec" = betterproto.message_field(5)
    metric_versions: List["Metric"] = betterproto.message_field(6)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MetricParentSpec(betterproto.Message):
    # @exclude @inject_tag: `bigquery:"dimension_id"`
    tags: List["TagSpec"] = betterproto.message_field(8)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class GetReportRequest(betterproto.Message):
    metric_id: str = betterproto.string_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class GetReportResponse(betterproto.Message):
    # @exclude @inject_tag: `bigquery:"dimension_id"`
    report: "MetricReport" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class CreateMetricRequest(betterproto.Message):
    given_id: str = betterproto.string_field(1)
    name: str = betterproto.string_field(2)
    spec: "MetricSpec" = betterproto.message_field(3)
    description: str = betterproto.string_field(4)
    version_spec: "VersionSpec" = betterproto.message_field(5)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ListMetricValuesRequest(betterproto.Message):
    metric_id: str = betterproto.string_field(1)
    feature_filter: List[str] = betterproto.string_field(2)
    dimension_filters: List["DimensionFilter"] = betterproto.message_field(3)
    observation_period_filter: "Period" = betterproto.message_field(4)
    page_size: int = betterproto.int32_field(5)
    page_token: str = betterproto.string_field(6)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ListMetricValuesResponse(betterproto.Message):
    values: List["MetricValue"] = betterproto.message_field(1)
    total_size: int = betterproto.int32_field(14)
    next_page_token: str = betterproto.string_field(15)

    def __post_init__(self) -> None:
        super().__post_init__()


class LensServiceStub(betterproto.ServiceStub):
    async def create_lens(
        self,
        *,
        catalog_id: str = "",
        metric_id: str = "",
        billing_account_id: str = "",
        lens_filters: "LensFilters" = None,
        display_name: str = "",
        description: str = "",
    ) -> "CreateLensResponse":

        request = CreateLensRequest()
        request.catalog_id = catalog_id
        request.metric_id = metric_id
        request.billing_account_id = billing_account_id
        if lens_filters is not None:
            request.lens_filters = lens_filters
        request.display_name = display_name
        request.description = description

        return await self._unary_unary(
            "/unacast.metric.v1.LensService/CreateLens", request, CreateLensResponse
        )

    async def get_lens(self, *, billing_context: str = "", lens_id: str = "") -> "Lens":

        request = GetLensRequest()
        request.billing_context = billing_context
        request.lens_id = lens_id

        return await self._unary_unary(
            "/unacast.metric.v1.LensService/GetLens", request, Lens
        )

    async def list_lenses(
        self,
        *,
        catalog_id: str = "",
        billing_context: str = "",
        creator_email_filter: str = "",
        metric_id_filter: Optional[List[str]] = None,
        page_size: int = 0,
        page_token: str = "",
    ) -> "ListLensesResponse":
        metric_id_filter = metric_id_filter or []

        request = ListLensesRequest()
        request.catalog_id = catalog_id
        request.billing_context = billing_context
        request.creator_email_filter = creator_email_filter
        request.metric_id_filter = metric_id_filter
        request.page_size = page_size
        request.page_token = page_token

        return await self._unary_unary(
            "/unacast.metric.v1.LensService/ListLenses", request, ListLensesResponse
        )

    async def delete_lens(
        self, *, billing_context: str = "", lens_id: str = ""
    ) -> "betterproto_lib_google_protobuf.Empty":

        request = DeleteLensRequest()
        request.billing_context = billing_context
        request.lens_id = lens_id

        return await self._unary_unary(
            "/unacast.metric.v1.LensService/DeleteLens",
            request,
            betterproto_lib_google_protobuf.Empty,
        )


from ... import unatype as __unatype__
from ...index import v1 as __index_v1__
from ...maps import v1 as __maps_v1__
from ...subscription import v1 as __subscription_v1__
import betterproto.lib.google.protobuf as betterproto_lib_google_protobuf
